function [u,v,T,U,imat,imat1,imat2,f] = init(N, time_disc, A, B, C, D, m, tau)

u0 = zeros(2*N+2,1);
u0(2*N+2) = 1;

t = 0;
if (time_disc == 0)
   mat = eye(2*N+2) - tau*[A B;C D];
   imat = inv(mat);
   f = zeros(2*N+2,1);
   %f(2*N+2) = -1/m;
   u = u0;
   U = u(2*N+1);
   
   imat1 = [];
   imat2 = [];
   v = [];
else
   mat1 = eye(2*N) - tau*A;
   mat2 = eye(2) - tau*D;
   imat1 = inv(mat1);
   imat2 = inv(mat2);
   f = [0;-1/m];
   u = u0(1:2*N);
   v = u0(2*N+1:2*N+2);
   U = v(1);
   
   imat = [];
end

T = t;
